/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.33 Revision 1.124
1# Copyright 2007-2009 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.33 2009/05/12 14:21:22 hwoarang Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.124 2012/04/04 16:37:50 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
11# @DESCRIPTION: 9# @DESCRIPTION:
12# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
13 11
14inherit eutils multilib toolchain-funcs flag-o-matic versionator
15
16IUSE="${IUSE} custom-cxxflags debug pch"
17
18case "${PV}" in 12case ${EAPI} in
19 4.?.?_rc*) 13 2|3|4) : ;;
20 SRCTYPE="${SRCTYPE:-opensource-src}" 14 *) die "qt4-build.eclass requires EAPI 2, 3 or 4." ;;
15esac
16
17inherit base eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.nokia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
28
21 MY_PV="${PV/_rc/-rc}" 29MY_PV=${PV/_/-}
30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH="${PV%.9999}"
22 ;; 37 ;;
23 *) 38 release)
24 SRCTYPE="${SRCTYPE:-opensource-src}" 39 SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
25 MY_PV="${PV}"
26 ;; 40 ;;
27esac 41esac
28MY_P=qt-x11-${SRCTYPE}-${MY_PV} 42
43IUSE="aqua debug pch"
44if [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]]; then
45 IUSE+=" +exceptions"
46fi
47if version_is_at_least 4.8; then
48 IUSE+=" c++0x qpa"
49fi
50
51DEPEND="dev-util/pkgconfig"
52if [[ ${QT4_BUILD_TYPE} == live ]]; then
53 DEPEND+=" dev-lang/perl"
54fi
55
56RDEPEND="
57 !<x11-libs/qt-assistant-${PV}
58 !>x11-libs/qt-assistant-${PV}-r9999
59 !<x11-libs/qt-core-${PV}
60 !>x11-libs/qt-core-${PV}-r9999
61 !<x11-libs/qt-dbus-${PV}
62 !>x11-libs/qt-dbus-${PV}-r9999
63 !<x11-libs/qt-declarative-${PV}
64 !>x11-libs/qt-declarative-${PV}-r9999
65 !<x11-libs/qt-demo-${PV}
66 !>x11-libs/qt-demo-${PV}-r9999
67 !<x11-libs/qt-gui-${PV}
68 !>x11-libs/qt-gui-${PV}-r9999
69 !<x11-libs/qt-multimedia-${PV}
70 !>x11-libs/qt-multimedia-${PV}-r9999
71 !<x11-libs/qt-opengl-${PV}
72 !>x11-libs/qt-opengl-${PV}-r9999
73 !<x11-libs/qt-openvg-${PV}
74 !>x11-libs/qt-openvg-${PV}-r9999
75 !<x11-libs/qt-phonon-${PV}
76 !>x11-libs/qt-phonon-${PV}-r9999
77 !<x11-libs/qt-qt3support-${PV}
78 !>x11-libs/qt-qt3support-${PV}-r9999
79 !<x11-libs/qt-script-${PV}
80 !>x11-libs/qt-script-${PV}-r9999
81 !<x11-libs/qt-sql-${PV}
82 !>x11-libs/qt-sql-${PV}-r9999
83 !<x11-libs/qt-svg-${PV}
84 !>x11-libs/qt-svg-${PV}-r9999
85 !<x11-libs/qt-test-${PV}
86 !>x11-libs/qt-test-${PV}-r9999
87 !<x11-libs/qt-webkit-${PV}
88 !>x11-libs/qt-webkit-${PV}-r9999
89 !<x11-libs/qt-xmlpatterns-${PV}
90 !>x11-libs/qt-xmlpatterns-${PV}-r9999
91"
92
29S=${WORKDIR}/${MY_P} 93S=${WORKDIR}/${MY_P}
30 94
31HOMEPAGE="http://www.qtsoftware.com/" 95# @FUNCTION: qt4-build_pkg_setup
32SRC_URI="http://download.qtsoftware.com/qt/source/${MY_P}.tar.bz2" 96# @DESCRIPTION:
33 97# Sets up PATH and LD_LIBRARY_PATH.
34case "${PV}" in
35 4.4.?) SRC_URI="${SRC_URI} mirror://gentoo/${MY_P}-headers.tar.bz2" ;;
36 *) ;;
37esac
38
39if version_is_at_least 4.5 ${PV} ; then
40 LICENSE="|| ( LGPL-2.1 GPL-3 )"
41fi
42
43qt4-build_pkg_setup() { 98qt4-build_pkg_setup() {
44 # EAPI=2 ebuilds set use-deps, others need this: 99 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
45 if [[ $EAPI != 2 ]]; then 100
46 # Make sure debug setting corresponds with qt-core (bug 258512) 101 # Protect users by not allowing downgrades between releases
47 if [[ $PN != "qt-core" ]]; then 102 # Downgrading revisions within the same release should be allowed
48 use debug && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK} 103 if has_version '>'${CATEGORY}/${P}-r9999; then
49 ~x11-libs/qt-core-${PV} debug" 104 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
105 eerror
106 eerror "Sanity check to keep you from breaking your system:"
107 eerror " Downgrading Qt is completely unsupported and will break your system!"
108 eerror
109 die "aborting to save your system"
110 else
111 ewarn "Downgrading Qt is completely unsupported and will break your system!"
50 fi 112 fi
113 fi
51 114
52 # Check USE requirements 115 if [[ ${PN} == qt-webkit ]]; then
53 qt4-build_check_use 116 eshopts_push -s extglob
117 if is-flagq '-g?(gdb)?([1-9])'; then
118 echo
119 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
120 ewarn "You may experience really long compilation times and/or increased memory usage."
121 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
122 ewarn "For more info check out bug #307861"
123 echo
54 fi 124 fi
55 # Set up installation directories 125 eshopts_pop
56 QTBASEDIR=/usr/$(get_libdir)/qt4 126 fi
57 QTPREFIXDIR=/usr
58 QTBINDIR=/usr/bin
59 QTLIBDIR=/usr/$(get_libdir)/qt4
60 QTPCDIR=/usr/$(get_libdir)/pkgconfig
61 QTDATADIR=/usr/share/qt4
62 QTDOCDIR=/usr/share/doc/qt-${PV}
63 QTHEADERDIR=/usr/include/qt4
64 QTPLUGINDIR=${QTLIBDIR}/plugins
65 QTSYSCONFDIR=/etc/qt4
66 QTTRANSDIR=${QTDATADIR}/translations
67 QTEXAMPLESDIR=${QTDATADIR}/examples
68 QTDEMOSDIR=${QTDATADIR}/demos
69 127
70 PLATFORM=$(qt_mkspecs_dir)
71
72 PATH="${S}/bin:${PATH}" 128 PATH="${S}/bin${PATH:+:}${PATH}"
129 if [[ ${CHOST} != *-darwin* ]]; then
73 LD_LIBRARY_PATH="${S}/lib:${LD_LIBRARY_PATH}" 130 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
131 else
132 DYLD_LIBRARY_PATH="${S}/lib${DYLD_LIBRARY_PATH:+:}${DYLD_LIBRARY_PATH}"
133 # On MacOS we *need* at least src/gui/kernel/qapplication_mac.mm for
134 # platform detection. Note: needs to come before any directories to
135 # avoid extract failure.
136 [[ ${CHOST} == *-apple-darwin* ]] && \
137 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
138 ${QT4_EXTRACT_DIRECTORIES}"
139 fi
74 140
75 if ! version_is_at_least 4.1 $(gcc-version) ; then 141 if ! version_is_at_least 4.1 $(gcc-version); then
76 ewarn "Using a GCC version lower than 4.1 is not supported!" 142 ewarn "Using a GCC version lower than 4.1 is not supported."
77 echo
78 ebeep 3
79 fi 143 fi
80
81 if use custom-cxxflags; then
82 echo
83 ewarn "You have set USE=custom-cxxflags, which means Qt will be built with the"
84 ewarn "CXXFLAGS you have set in /etc/make.conf. This is not supported, and we"
85 ewarn "recommend to unset this useflag. But you are free to experiment with it."
86 ewarn "Just do not start crying if it breaks your system, or eats your kitten"
87 ewarn "for breakfast. ;-) "
88 echo
89 fi
90
91} 144}
92 145
146# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
147# @DESCRIPTION:
148# Arguments for build_target_directories. Takes the directories in which the
149# code should be compiled. This is a space-separated list.
150
151# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
152# @DESCRIPTION:
153# Space-separated list including the directories that will be extracted from
154# Qt tarball.
155
156# @FUNCTION: qt4-build_src_unpack
157# @DESCRIPTION:
158# Unpacks the sources.
93qt4-build_src_unpack() { 159qt4-build_src_unpack() {
94 local target targets licenses 160 setqtenv
95 if version_is_at_least 4.5 ${PV} ; then 161
96 licenses="LICENSE.GPL3 LICENSE.LGPL" 162 case ${QT4_BUILD_TYPE} in
97 else 163 live)
98 licenses="LICENSE.GPL2 LICENSE.GPL3" 164 git-2_src_unpack
99 fi 165 ;;
100 for target in configure ${licenses} projects.pro \ 166 release)
167 local tarball="${MY_P}.tar.gz" target= targets=
168 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
101 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 169 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
102 ${QT4_EXTRACT_DIRECTORIES}; do 170 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
171 do
103 targets="${targets} ${MY_P}/${target}" 172 targets+="${MY_P}/${target} "
104 done 173 done
105 174
106 echo tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 175 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
107 tar xjpf "${DISTDIR}"/${MY_P}.tar.bz2 ${targets} 176 tar -xzf "${DISTDIR}/${tarball}" ${targets}
108 177 eend $? || die "failed to unpack"
109 case "${PV}" in
110 4.4.?)
111 echo tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
112 tar xjpf "${DISTDIR}"/${MY_P}-headers.tar.bz2
113 ;; 178 ;;
114 esac 179 esac
115
116 # Be backwards compatible for now
117 if [[ $EAPI != 2 ]]; then
118 qt4-build_src_prepare
119 fi
120} 180}
121 181
182# @ECLASS-VARIABLE: PATCHES
183# @DEFAULT_UNSET
184# @DESCRIPTION:
185# PATCHES array variable containing all various patches to be applied.
186# This variable is expected to be defined in global scope of ebuild.
187# Make sure to specify the full path. This variable is utilised in
188# src_unpack/src_prepare phase, based on EAPI.
189#
190# @CODE
191# PATCHES=( "${FILESDIR}/mypatch.patch"
192# "${FILESDIR}/patches_folder/" )
193# @CODE
194
195# @FUNCTION: qt4-build_src_prepare
196# @DESCRIPTION:
197# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
198# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in /etc/make.conf.
122qt4-build_src_prepare() { 199qt4-build_src_prepare() {
123 cd "${S}" 200 setqtenv
201
202 if [[ ${QT4_BUILD_TYPE} == live ]]; then
203 QTDIR="." ./bin/syncqt || die "syncqt failed"
204 fi
205
206 if version_is_at_least 4.7; then
207 # fix libX11 dependency on non X packages
208 local nolibx11_pkgs="qt-core qt-dbus qt-script qt-sql qt-test qt-xmlpatterns"
209 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
210
211 qt_assistant_cleanup
212 fi
213
214 if use aqua; then
215 # provide a proper macx-g++-64
216 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
217
218 sed -e '/^CONFIG/s:app_bundle::' \
219 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
220 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
221 fi
124 222
125 if [[ ${PN} != qt-core ]]; then 223 if [[ ${PN} != qt-core ]]; then
126 skip_qmake_build_patch 224 skip_qmake_build
127 skip_project_generation_patch 225 skip_project_generation
128 symlink_binaries_to_buildtree 226 symlink_binaries_to_buildtree
129 fi 227 fi
130 228
131 if ! use custom-cxxflags;then 229 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
132 # Don't let the user go too overboard with flags. 230 # qmake bus errors with -O2 or -O3 but -O1 works
133 strip-flags 231 # Bug 373061
134 replace-flags -O3 -O2 232 replace-flags -O[23] -O1
135 fi 233 fi
136 234
137 # Bug 178652 235 # Bug 178652
138 if [[ "$(gcc-major-version)" == "3" ]] && use amd64; then 236 if [[ $(gcc-major-version) == 3 ]] && use amd64; then
139 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS" 237 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
140 append-flags -fno-gcse 238 append-flags -fno-gcse
141 fi 239 fi
142 240
241 if use_if_iuse c++0x; then
242 echo
243 ewarn "You are about to build Qt4 using the C++11 standard. Even though"
244 ewarn "this is an official standard, some of the reverse dependencies"
245 ewarn "may fail to compile or link againt the Qt4 libraries. Before"
246 ewarn "reporting a bug, make sure your bug is reproducible with c++0x"
247 ewarn "disabled."
248 echo
249 append-flags -std=c++0x
250 fi
251
143 # Unsupported old gcc versions - hardened needs this :( 252 # Unsupported old gcc versions - hardened needs this :(
144 if [[ $(gcc-major-version) -lt "4" ]] ; then 253 if [[ $(gcc-major-version) -lt 4 ]]; then
145 ewarn "Appending -fno-stack-protector to CXXFLAGS" 254 ewarn "Appending -fno-stack-protector to CXXFLAGS"
146 append-cxxflags -fno-stack-protector 255 append-cxxflags -fno-stack-protector
147 # Bug 253127 256 # Bug 253127
148 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \ 257 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
149 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 258 -i mkspecs/common/g++.conf || die
150 fi 259 fi
260
261 # Bug 261632
262 if use ppc64; then
263 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
264 append-flags -mminimal-toc
265 fi
266
267 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
268 sed -e "/^SYSTEM_VARIABLES=/i \
269 CC='$(tc-getCC)'\n\
270 CXX='$(tc-getCXX)'\n\
271 CFLAGS='${CFLAGS}'\n\
272 CXXFLAGS='${CXXFLAGS}'\n\
273 LDFLAGS='${LDFLAGS}'\n" \
274 -i configure \
275 || die "sed SYSTEM_VARIABLES failed"
276
277 # Respect CC, CXX, LINK and *FLAGS in config.tests
278 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
279 sed -i -e "/bin\/qmake/ s: \"QT_BUILD_TREE=: \
280 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
281 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
282 || die "sed config.tests failed"
283
284 # Strip predefined CFLAGS from mkspecs (bug 312689)
285 sed -i -e '/^QMAKE_CFLAGS_RELEASE/s:+=.*:+=:' mkspecs/common/g++.conf || die
151 286
152 # Bug 172219 287 # Bug 172219
288 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
289
290 if [[ ${CHOST} == *-darwin* ]]; then
291 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
292 # crippled (by design) :/
293 local mac_gpp_conf=
294 if [[ -f mkspecs/common/mac-g++.conf ]]; then
295 # qt < 4.8 has mac-g++.conf
296 mac_gpp_conf="mkspecs/common/mac-g++.conf"
297 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
298 # qt >= 4.8 has g++-macx.conf
299 mac_gpp_conf="mkspecs/common/g++-macx.conf"
300 else
301 die "no known conf file for mac found"
302 fi
303 sed \
153 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 304 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
154 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 305 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
155 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 306 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
156 -e "s:X11R6/::" \ 307 -e "s:-arch\s\w*::g" \
157 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed" 308 -i ${mac_gpp_conf} \
309 || die "sed ${mac_gpp_conf} failed"
158 310
159 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 311 # Fix configure's -arch settings that appear in qmake/Makefile and also
160 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 312 # fix arch handling (automagically duplicates our -arch arg and breaks
161 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=${LDFLAGS}:" \ 313 # pch). Additionally disable Xarch support.
162 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed" 314 local mac_gcc_confs="${mac_gpp_conf}"
315 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
316 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
317 fi
318 sed \
319 -e "s:-arch i386::" \
320 -e "s:-arch ppc::" \
321 -e "s:-arch x86_64::" \
322 -e "s:-arch ppc64::" \
323 -e "s:-arch \$i::" \
324 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
325 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
326 -e "s:-Xarch_x86_64::g" \
327 -e "s:-Xarch_ppc64::g" \
328 -i configure ${mac_gcc_confs} \
329 || die "sed -arch/-Xarch failed"
163 330
164} 331 # On Snow Leopard don't fall back to 10.5 deployment target.
332 if [[ ${CHOST} == *-apple-darwin10 ]]; then
333 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
334 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
335 -i configure ${mac_gpp_conf} \
336 || die "sed deployment target failed"
337 fi
338 fi
165 339
340 # this one is needed for all systems with a separate -liconv, apart from
341 # Darwin, for which the sources already cater for -liconv
342 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
343 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
344 -i config.tests/unix/iconv/iconv.pro \
345 || die "sed iconv.pro failed"
346 fi
347
348 # we need some patches for Solaris
349 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
350 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
351 # use GCC over SunStudio
352 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
353 # do not flirt with non-Prefix stuff, we're quite possessive
354 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
355 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
356
357 base_src_prepare
358}
359
360# @FUNCTION: qt4-build_src_configure
361# @DESCRIPTION:
362# Default configure phase
166qt4-build_src_configure() { 363qt4-build_src_configure() {
364 setqtenv
167 365
168 myconf="$(standard_configure_options) ${myconf}"
169
170 echo ./configure ${myconf}
171 ./configure ${myconf} || die "./configure failed"
172}
173
174qt4-build_src_compile() {
175 # Be backwards compatible for now
176 if [[ $EAPI != 2 ]]; then
177 qt4-build_src_configure
178 fi
179
180 build_directories "${QT4_TARGET_DIRECTORIES}"
181}
182
183qt4-build_src_install() {
184 install_directories "${QT4_TARGET_DIRECTORIES}"
185 install_qconfigs
186 fix_library_files
187}
188
189standard_configure_options() {
190 local myconf="" 366 local conf="
191 367 -prefix ${QTPREFIXDIR}
192 [[ $(get_libdir) != "lib" ]] && myconf="${myconf} -L/usr/$(get_libdir)" 368 -bindir ${QTBINDIR}
193 369 -libdir ${QTLIBDIR}
194 # Disable visibility explicitly if gcc version isn't 4 370 -docdir ${QTDOCDIR}
195 if [[ "$(gcc-major-version)" -lt "4" ]]; then 371 -headerdir ${QTHEADERDIR}
196 myconf="${myconf} -no-reduce-exports" 372 -plugindir ${QTPLUGINDIR}
197 fi 373 $(version_is_at_least 4.7 && echo -importdir ${QTIMPORTDIR})
198 374 -datadir ${QTDATADIR}
199 # precompiled headers doesn't work on hardened, where the flag is masked. 375 -translationdir ${QTTRANSDIR}
200 if use pch; then 376 -sysconfdir ${QTSYSCONFDIR}
201 myconf="${myconf} -pch" 377 -examplesdir ${QTEXAMPLESDIR}
202 else 378 -demosdir ${QTDEMOSDIR}
203 myconf="${myconf} -no-pch" 379 -opensource -confirm-license
204 fi 380 -shared -fast -largefile -stl -verbose
205 381 -nomake examples -nomake demos"
206 if use debug; then
207 myconf="${myconf} -debug -no-separate-debug-info"
208 else
209 myconf="${myconf} -release -no-separate-debug-info"
210 fi
211 382
212 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported 383 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
213 # $(tc-arch). Therefore we convert it to supported values. 384 # $(tc-arch). Therefore we convert it to supported values.
214 case "$(tc-arch)" in 385 case "$(tc-arch)" in
215 amd64) myconf="${myconf} -arch x86_64" ;; 386 amd64|x64-*) conf+=" -arch x86_64" ;;
387 ppc-macos) conf+=" -arch ppc" ;;
216 ppc|ppc64) myconf="${myconf} -arch powerpc" ;; 388 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
389 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
390 x86-macos) conf+=" -arch x86" ;;
217 x86|x86-*) myconf="${myconf} -arch i386" ;; 391 x86|x86-*) conf+=" -arch i386" ;;
218 alpha|arm|ia64|mips|s390|sparc) myconf="${myconf} -arch $(tc-arch)" ;; 392 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
219 hppa|sh) myconf="${myconf} -arch generic" ;; 393 hppa|sh) conf+=" -arch generic" ;;
220 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;; 394 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
221 esac 395 esac
222 396
223 # Bug 261412 Qt configure detects archs by uname 397 conf+=" -platform $(qt_mkspecs_dir)"
224 case "$(tc-arch)" in
225 ppc) myconf="${myconf} -platform linux-g++-32";;
226 esac
227 398
228 myconf="${myconf} -stl -verbose -largefile -confirm-license -no-rpath 399 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
229 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
230 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
231 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
232 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
233 -demosdir ${QTDEMOSDIR} -silent -fast
234 $([[ ${PN} == qt-xmlpatterns ]] || echo -no-exceptions)
235 -reduce-relocations -nomake examples -nomake demos"
236
237 # Make eclass 4.5.{1,2} ready
238 case "${MY_PV}" in
239 4.5.1 | 4.5.2)
240 myconf="${myconf} -opensource"
241 ;;
242 esac
243 400
401 # debug/release
402 if use debug; then
403 conf+=" -debug"
404 else
405 conf+=" -release"
406 fi
407 conf+=" -no-separate-debug-info"
408
409 # exceptions USE flag
410 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
411
412 # disable RPATH on Qt >= 4.8 (bug 380415)
413 version_is_at_least 4.8 && conf+=" -no-rpath"
414
415 # precompiled headers don't work on hardened, where the flag is masked
416 conf+=" $(qt_use pch)"
417
418 # -reduce-relocations
419 # This flag seems to introduce major breakage to applications,
420 # mostly to be seen as a core dump with the message "QPixmap: Must
421 # construct a QApplication before a QPaintDevice" on Solaris.
422 # -- Daniel Vergien
423 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
424
425 # this one is needed for all systems with a separate -liconv, apart from
426 # Darwin, for which the sources already cater for -liconv
427 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
428 conf+=" -liconv"
429 fi
430
431 if use_if_iuse glib; then
432 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
433 # avoid the -pthread argument
434 conf+=" ${glibflags//-pthread}"
435 unset glibflags
436 fi
437
438 if use_if_iuse qpa; then
439 echo
440 ewarn "The qpa useflag enables the Qt Platform Abstraction, formely"
441 ewarn "known as Qt Lighthouse. If you are not sure what that is, then"
442 ewarn "disable it before reporting any bugs related to this useflag."
443 echo
444 conf+=" -qpa"
445 fi
446
447 if use aqua; then
448 # On (snow) leopard use the new (frameworked) cocoa code.
449 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
450 conf+=" -cocoa -framework"
451 # We need the source's headers, not the installed ones.
452 conf+=" -I${S}/include"
453 # Add hint for the framework location.
454 conf+=" -F${QTLIBDIR}"
455
456 # We are crazy and build cocoa + qt3support :-)
457 if use qt3support; then
458 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
459 -i configure || die
460 fi
461 else
462 conf+=" -no-framework"
463 fi
464 else
465 # freetype2 include dir is non-standard, thus pass it to configure
466 conf+=" $(pkg-config --cflags-only-I freetype2)"
467 fi
468
244 echo "${myconf}" 469 conf+=" ${myconf}"
245} 470 myconf=
246 471
472 echo ./configure ${conf}
473 ./configure ${conf} || die "./configure failed"
474
475 prepare_directories ${QT4_TARGET_DIRECTORIES}
476}
477
478# @FUNCTION: qt4-build_src_compile
479# @DESCRIPTION:
480# Actual compile phase
481qt4-build_src_compile() {
482 setqtenv
483
484 build_directories ${QT4_TARGET_DIRECTORIES}
485}
486
487# @FUNCTION: qt4-build_src_test
488# @DESCRIPTION:
489# Runs tests only in target directories.
490qt4-build_src_test() {
491 # QtMultimedia does not have any test suite (bug #332299)
492 [[ ${PN} == qt-multimedia ]] && return
493
494 for dir in ${QT4_TARGET_DIRECTORIES}; do
495 emake -j1 check -C ${dir}
496 done
497}
498
499# @FUNCTION: fix_includes
500# @DESCRIPTION:
501# For MacOS X we need to add some symlinks when frameworks are
502# being used, to avoid complications with some more or less stupid packages.
503fix_includes() {
504 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
505 # Some packages tend to include <Qt/...>
506 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
507
508 # Fake normal headers when frameworks are installed... eases life later on
509 local dest f h
510 for frw in "${D}${QTLIBDIR}"/*.framework; do
511 [[ -e "${frw}"/Headers ]] || continue
512 f=$(basename ${frw})
513 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
514 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}"
515
516 # Link normal headers as well.
517 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
518 h=$(basename ${hdr})
519 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
520 done
521 done
522 fi
523}
524
525# @FUNCTION: qt4-build_src_install
526# @DESCRIPTION:
527# Perform the actual installation including some library fixes.
528qt4-build_src_install() {
529 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
530 setqtenv
531
532 install_directories ${QT4_TARGET_DIRECTORIES}
533 install_qconfigs
534 fix_library_files
535 fix_includes
536
537 # remove .la files since we are building only shared Qt libraries
538 find "${D}"${QTLIBDIR} -type f -name '*.la' -print0 | xargs -0 rm -f
539}
540
541# @FUNCTION: setqtenv
542# @INTERNAL
543setqtenv() {
544 # Set up installation directories
545 QTPREFIXDIR=${EPREFIX}/usr
546 QTBINDIR=${EPREFIX}/usr/bin
547 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4
548 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig
549 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV}
550 QTHEADERDIR=${EPREFIX}/usr/include/qt4
551 QTPLUGINDIR=${QTLIBDIR}/plugins
552 QTIMPORTDIR=${QTLIBDIR}/imports
553 QTDATADIR=${EPREFIX}/usr/share/qt4
554 QTTRANSDIR=${QTDATADIR}/translations
555 QTSYSCONFDIR=${EPREFIX}/etc/qt4
556 QTEXAMPLESDIR=${QTDATADIR}/examples
557 QTDEMOSDIR=${QTDATADIR}/demos
558 QMAKE_LIBDIR_QT=${QTLIBDIR}
559 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4
560
561 PLATFORM=$(qt_mkspecs_dir)
562
563 unset QMAKESPEC
564}
565
566# @FUNCTION: prepare_directories
567# @USAGE: < directories >
568# @INTERNAL
569# @DESCRIPTION:
570# Generates Makefiles for the given list of directories.
571prepare_directories() {
572 for x in "$@"; do
573 pushd "${S}"/${x} >/dev/null || die
574 einfo "Running qmake in: ${x}"
575 # avoid running over the maximum argument number, bug #299810
576 {
577 echo "${S}"/mkspecs/common/*.conf
578 find "${S}" -name '*.pr[io]'
579 } | xargs sed -i \
580 -e "s:\$\$\[QT_INSTALL_LIBS\]:${QTLIBDIR}:g" \
581 -e "s:\$\$\[QT_INSTALL_PLUGINS\]:${QTPLUGINDIR}:g" \
582 || die
583 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
584 popd >/dev/null || die
585 done
586}
587
588
589# @FUNCTION: build_directories
590# @USAGE: < directories >
591# @INTERNAL
592# @DESCRIPTION:
593# Compiles the code in the given list of directories.
247build_directories() { 594build_directories() {
248 local dirs="$@"
249 for x in ${dirs}; do 595 for x in "$@"; do
250 cd "${S}"/${x} 596 pushd "${S}"/${x} >/dev/null || die
251 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed" 597 emake CC="$(tc-getCC)" \
252 emake || die "emake failed" 598 CXX="$(tc-getCXX)" \
599 LINK="$(tc-getCXX)" || die "emake failed"
600 popd >/dev/null || die
253 done 601 done
254} 602}
255 603
604# @FUNCTION: install_directories
605# @USAGE: < directories >
606# @INTERNAL
607# @DESCRIPTION:
608# Runs emake install in the given directories, which are separated by spaces.
256install_directories() { 609install_directories() {
257 local dirs="$@"
258 for x in ${dirs}; do 610 for x in "$@"; do
259 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 611 pushd "${S}"/${x} >/dev/null || die
260 emake INSTALL_ROOT="${D}" install || die "emake install failed" 612 emake INSTALL_ROOT="${D}" install || die "emake install failed"
261 popd >/dev/null || die "Can't popd from ${S}/${x}" 613 popd >/dev/null || die
262 done 614 done
263} 615}
264 616
265# @ECLASS-VARIABLE: QCONFIG_ADD 617# @ECLASS-VARIABLE: QCONFIG_ADD
266# @DESCRIPTION: 618# @DESCRIPTION:
267# List options that need to be added to QT_CONFIG in qconfig.pri 619# List options that need to be added to QT_CONFIG in qconfig.pri
268QCONFIG_ADD="${QCONFIG_ADD:-}" 620: ${QCONFIG_ADD:=}
269 621
270# @ECLASS-VARIABLE: QCONFIG_REMOVE 622# @ECLASS-VARIABLE: QCONFIG_REMOVE
271# @DESCRIPTION: 623# @DESCRIPTION:
272# List options that need to be removed from QT_CONFIG in qconfig.pri 624# List options that need to be removed from QT_CONFIG in qconfig.pri
273QCONFIG_REMOVE="${QCONFIG_REMOVE:-}" 625: ${QCONFIG_REMOVE:=}
274 626
275# @ECLASS-VARIABLE: QCONFIG_DEFINE 627# @ECLASS-VARIABLE: QCONFIG_DEFINE
276# @DESCRIPTION: 628# @DESCRIPTION:
277# List variables that should be defined at the top of QtCore/qconfig.h 629# List variables that should be defined at the top of QtCore/qconfig.h
278QCONFIG_DEFINE="${QCONFIG_DEFINE:-}" 630: ${QCONFIG_DEFINE:=}
279 631
632# @FUNCTION: install_qconfigs
633# @INTERNAL
634# @DESCRIPTION:
635# Install gentoo-specific mkspecs configurations.
280install_qconfigs() { 636install_qconfigs() {
281 local x 637 local x
282 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 638 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
283 for x in QCONFIG_ADD QCONFIG_REMOVE; do 639 for x in QCONFIG_ADD QCONFIG_REMOVE; do
284 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 640 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
285 done 641 done
286 insinto ${QTDATADIR}/mkspecs/gentoo 642 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
287 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 643 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed"
288 fi 644 fi
289 645
290 if [[ -n ${QCONFIG_DEFINE} ]]; then 646 if [[ -n ${QCONFIG_DEFINE} ]]; then
291 for x in ${QCONFIG_DEFINE}; do 647 for x in ${QCONFIG_DEFINE}; do
292 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 648 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
293 done 649 done
294 insinto ${QTHEADERDIR}/Gentoo 650 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
295 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 651 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed"
296 fi 652 fi
297} 653}
298 654
655# @FUNCTION: generate_qconfigs
656# @INTERNAL
657# @DESCRIPTION:
658# Generates gentoo-specific qconfig.{h,pri}.
299generate_qconfigs() { 659generate_qconfigs() {
300 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 660 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${PN} == qt-core ]]; then
301 local x qconfig_add qconfig_remove qconfig_new 661 local x qconfig_add qconfig_remove qconfig_new
302 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 662 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
303 [[ -f ${x} ]] || continue 663 [[ -f ${x} ]] || continue
304 qconfig_add="${qconfig_add} $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 664 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
305 qconfig_remove="${qconfig_remove} $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 665 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
306 done 666 done
307 667
308 # these error checks do not use die because dying in pkg_post{inst,rm} 668 # these error checks do not use die because dying in pkg_post{inst,rm}
309 # just makes things worse. 669 # just makes things worse.
310 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 670 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
317 677
318 # generate list of QT_CONFIG entries from the existing list 678 # generate list of QT_CONFIG entries from the existing list
319 # including qconfig_add and excluding qconfig_remove 679 # including qconfig_add and excluding qconfig_remove
320 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 680 for x in $(sed -n 's/^QT_CONFIG +=//p' \
321 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 681 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
322 hasq ${x} ${qconfig_remove} || qconfig_new="${qconfig_new} ${x}" 682 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
323 done 683 done
324 684
325 # replace the existing QT_CONFIG list with qconfig_new 685 # replace the existing QT_CONFIG list with qconfig_new
326 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 686 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
327 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 687 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
350 "${ROOT}${QTHEADERDIR}" 2>/dev/null 710 "${ROOT}${QTHEADERDIR}" 2>/dev/null
351 fi 711 fi
352 fi 712 fi
353} 713}
354 714
715# @FUNCTION: qt4-build_pkg_postrm
716# @DESCRIPTION:
717# Regenerate configuration when the package is completely removed.
355qt4-build_pkg_postrm() { 718qt4-build_pkg_postrm() {
356 generate_qconfigs 719 generate_qconfigs
357} 720}
358 721
722# @FUNCTION: qt4-build_pkg_postinst
723# @DESCRIPTION:
724# Regenerate configuration, plus throw a message about possible
725# breakages and proposed solutions.
359qt4-build_pkg_postinst() { 726qt4-build_pkg_postinst() {
360 generate_qconfigs 727 generate_qconfigs
361 echo
362 ewarn "After a rebuild or upgrade of Qt, it can happen that Qt plugins (such as Qt"
363 ewarn "and KDE styles and widgets) can no longer be loaded. In this situation you"
364 ewarn "should recompile the packages providing these plugins. Also, make sure you"
365 ewarn "compile the Qt packages, and the packages that depend on it, with the same"
366 ewarn "GCC version and the same USE flag settings (especially the debug flag)."
367 ewarn
368 ewarn "Packages that typically need to be recompiled are kdelibs from KDE4, any"
369 ewarn "additional KDE4/Qt4 styles, qscintilla and PyQt4. Before filing a bug report,"
370 ewarn "make sure all your Qt4 packages are up-to-date and built with the same"
371 ewarn "configuration."
372 ewarn
373 ewarn "For more information, see http://doc.trolltech.com/4.4/plugins-howto.html"
374 echo
375} 728}
376 729
730# @FUNCTION: skip_qmake_build
731# @INTERNAL
732# @DESCRIPTION:
733# Patches configure to skip qmake compilation, as it's already installed by qt-core.
377skip_qmake_build_patch() { 734skip_qmake_build() {
378 # Don't need to build qmake, as it's already installed from qt-core
379 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 735 sed -i -e "s:if true:if false:g" "${S}"/configure || die
380} 736}
381 737
382skip_project_generation_patch() { 738# @FUNCTION: skip_project_generation
739# @INTERNAL
740# @DESCRIPTION:
383 # Exit the script early by throwing in an exit before all of the .pro files are scanned 741# Exit the script early by throwing in an exit before all of the .pro files are scanned.
742skip_project_generation() {
384 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 743 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
385 -i "${S}"/configure || die "Sed failed"
386} 744}
387 745
746# @FUNCTION: symlink_binaries_to_buildtree
747# @INTERNAL
748# @DESCRIPTION:
749# Symlinks generated binaries to buildtree, so they can be used during compilation time.
388symlink_binaries_to_buildtree() { 750symlink_binaries_to_buildtree() {
389 for bin in qmake moc uic rcc; do 751 for bin in qmake moc uic rcc; do
390 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 752 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
391 done 753 done
392} 754}
393 755
756# @FUNCTION: fix_library_files
757# @INTERNAL
758# @DESCRIPTION:
759# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
760# moves the *.pc files into the pkgconfig directory.
394fix_library_files() { 761fix_library_files() {
762 local libfile
395 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 763 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
396 if [[ -e ${libfile} ]]; then 764 if [[ -e ${libfile} ]]; then
397 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 765 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
398 fi 766 fi
399 done 767 done
400 768
401 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 769 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
402 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 770 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
403 if [[ -e ${libfile} ]]; then 771 if [[ -e ${libfile} ]]; then
404 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 772 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
405 773
406 # Move .pc files into the pkgconfig directory 774 # Move .pc files into the pkgconfig directory
407
408 dodir ${QTPCDIR} 775 dodir ${QTPCDIR#${EPREFIX}}
409 mv ${libfile} "${D}"/${QTPCDIR}/ \ 776 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
410 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
411 fi 777 fi
412 done 778 done
413 779
414 # Don't install an empty directory 780 # Don't install an empty directory
415 rmdir "${D}"/${QTLIBDIR}/pkgconfig 781 rmdir "${D}"/${QTLIBDIR}/pkgconfig
416} 782}
417 783
784# @FUNCTION: qt_use
785# @USAGE: < flag > [ feature ] [ enableval ]
786# @DESCRIPTION:
787# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
788# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
789# will be used for that. If [enableval] is not specified, it omits the
790# "-${enableval}" part.
418qt_use() { 791qt_use() {
419 local flag="${1}" 792 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
420 local feature="${1}"
421 local enableval=
422
423 [[ -n ${2} ]] && feature=${2}
424 [[ -n ${3} ]] && enableval="-${3}"
425
426 if use ${flag}; then
427 echo "${enableval}-${feature}"
428 else
429 echo "-no-${feature}"
430 fi
431} 793}
432 794
433# @ECLASS-VARIABLE: QT4_BUILT_WITH_USE_CHECK 795# @FUNCTION: qt_mkspecs_dir
796# @RETURN: the specs-directory w/o path
434# @DESCRIPTION: 797# @DESCRIPTION:
435# The contents of $QT4_BUILT_WITH_USE_CHECK gets fed to built_with_use 798# Allows us to define which mkspecs dir we want to use.
436# (eutils.eclass), line per line.
437#
438# Example:
439# @CODE
440# pkg_setup() {
441# use qt3support && QT4_BUILT_WITH_USE_CHECK="${QT4_BUILT_WITH_USE_CHECK}
442# ~x11-libs/qt-gui-${PV} qt3support"
443# qt4-build_check_use
444# }
445# @CODE
446
447# Run built_with_use on each flag and print appropriate error messages if any
448# flags are missing
449_qt_built_with_use() {
450 local missing opt pkg flag flags
451
452 if [[ ${1} = "--missing" ]]; then
453 missing="${1} ${2}" && shift 2
454 fi
455 if [[ ${1:0:1} = "-" ]]; then
456 opt=${1} && shift
457 fi
458
459 pkg=${1} && shift
460
461 for flag in "${@}"; do
462 flags="${flags} ${flag}"
463 if ! built_with_use ${missing} ${opt} ${pkg} ${flag}; then
464 flags="${flags}*"
465 else
466 [[ ${opt} = "-o" ]] && return 0
467 fi
468 done
469 if [[ "${flags# }" = "${@}" ]]; then
470 return 0
471 fi
472 if [[ ${opt} = "-o" ]]; then
473 eerror "This package requires '${pkg}' to be built with any of the following USE flags: '$*'."
474 else
475 eerror "This package requires '${pkg}' to be built with the following USE flags: '${flags# }'."
476 fi
477 return 1
478}
479
480# @FUNCTION: qt4-build_check_use
481# @DESCRIPTION:
482# Check if the listed packages in $QT4_BUILT_WITH_USE_CHECK are built with the
483# USE flags listed.
484#
485# If any of the required USE flags are missing, an eerror will be printed for
486# each package with missing USE flags.
487qt4-build_check_use() {
488 local line missing
489 while read line; do
490 [[ -z ${line} ]] && continue
491 if ! _qt_built_with_use ${line}; then
492 missing=true
493 fi
494 done <<< "${QT4_BUILT_WITH_USE_CHECK}"
495 if [[ -n ${missing} ]]; then
496 echo
497 eerror "Flags marked with an * are missing."
498 die "Missing USE flags found"
499 fi
500}
501
502qt_mkspecs_dir() { 799qt_mkspecs_dir() {
503 # Allows us to define which mkspecs dir we want to use.
504 local spec 800 local spec=
505 801
506 case ${CHOST} in 802 case "${CHOST}" in
507 *-freebsd*|*-dragonfly*) 803 *-freebsd*|*-dragonfly*)
508 spec="freebsd" ;; 804 spec=freebsd ;;
509 *-openbsd*) 805 *-openbsd*)
510 spec="openbsd" ;; 806 spec=openbsd ;;
511 *-netbsd*) 807 *-netbsd*)
512 spec="netbsd" ;; 808 spec=netbsd ;;
513 *-darwin*) 809 *-darwin*)
810 if use aqua; then
811 # mac with carbon/cocoa
812 spec=macx
813 else
814 # darwin/mac with x11
514 spec="darwin" ;; 815 spec=darwin
816 fi
817 ;;
818 *-solaris*)
819 spec=solaris ;;
515 *-linux-*|*-linux) 820 *-linux-*|*-linux)
516 spec="linux" ;; 821 spec=linux ;;
517 *) 822 *)
518 die "Unknown CHOST, no platform choosen." 823 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
519 esac 824 esac
520 825
521 CXX=$(tc-getCXX) 826 case "$(tc-getCXX)" in
522 if [[ ${CXX/g++/} != ${CXX} ]]; then 827 *g++*)
523 spec="${spec}-g++" 828 spec+=-g++ ;;
524 elif [[ ${CXX/icpc/} != ${CXX} ]]; then 829 *icpc*)
525 spec="${spec}-icc" 830 spec+=-icc ;;
526 else 831 *)
527 die "Unknown compiler ${CXX}." 832 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
833 esac
834
835 # Add -64 for 64bit profiles
836 if use x64-freebsd ||
837 use amd64-linux ||
838 use x64-macos ||
839 use x64-solaris ||
840 use sparc64-solaris
841 then
842 spec+=-64
528 fi 843 fi
529 844
530 echo "${spec}" 845 echo "${spec}"
531} 846}
532 847
533case ${EAPI:-0} in 848# @FUNCTION: qt_assistant_cleanup
534 0|1) EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postrm pkg_postinst ;; 849# @INTERNAL
850# @DESCRIPTION:
851# Tries to clean up tools.pro for qt-assistant ebuilds.
852# Meant to be called in src_prepare().
853# Since Qt 4.7.4 this function is a no-op.
854qt_assistant_cleanup() {
855 # apply patching to qt-assistant ebuilds only
856 [[ ${PN} != qt-assistant ]] && return
857
858 # no longer needed for 4.7.4 and later
859 version_is_at_least 4.7.4 && return
860
861 # different versions (and branches...) may need different handling,
862 # add a case if you need special handling
863 case "${MY_PV_EXTRA}" in
864 *kde-qt*)
865 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
866 -e "/mac/,/^embedded.*makeqpf$/d" \
867 -i tools/tools.pro || die "patching tools.pro failed"
868 ;;
869 *)
870 sed -e "/^[ \t]*porting/,/^[ \t]*win32.*activeqt$/d" \
871 -e "/mac/,/^embedded.*makeqpf$/d" \
872 -e "s/^\([ \t]*pixeltool\) /\1 qdoc3 /" \
873 -i tools/tools.pro || die "patching tools.pro failed"
874 ;;
875 esac
876}
877
878# @FUNCTION: qt_nolibx11
879# @INTERNAL
880# @DESCRIPTION:
881# Ignore X11 tests for packages that don't need X libraries installed.
882qt_nolibx11() {
883 sed -i "/unixtests\/compile.test.*config.tests\/x11\/xlib/,/fi$/d" "${S}"/configure ||
884 die "x11 check sed failed"
885}
886
535 2) EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install pkg_postrm pkg_postinst ;; 887EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst
536esac

Legend:
Removed from v.1.33  
changed lines
  Added in v.1.124

  ViewVC Help
Powered by ViewVC 1.1.20